(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('tscommons-core'), require('ngx-httpcommons-rest'), require('ngx-adamantinecommons-core'), require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-adamantinecommons-rest', ['exports', 'tscommons-core', 'ngx-httpcommons-rest', 'ngx-adamantinecommons-core', '@angular/core', '@angular/common'], factory) :
    (global = global || self, factory(global['ngx-adamantinecommons-rest'] = {}, global.tscommonsCore, global.ngxHttpcommonsRest, global.ngxAdamantinecommonsCore, global.ng.core, global.ng.common));
}(this, function (exports, tscommonsCore, ngxHttpcommonsRest, ngxAdamantinecommonsCore, core, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var   /**
     * @abstract
     */
    AdamantineRestService = /** @class */ (function (_super) {
        __extends(AdamantineRestService, _super);
        function AdamantineRestService(rootURL, http) {
            return _super.call(this, rootURL, http) || this;
        }
        /**
         * @param {?} fields
         * @return {?}
         */
        AdamantineRestService.buildFieldLookup = /**
         * @param {?} fields
         * @return {?}
         */
        function (fields) {
            var e_1, _a;
            /** @type {?} */
            var map = new Map();
            try {
                for (var fields_1 = __values(fields), fields_1_1 = fields_1.next(); !fields_1_1.done; fields_1_1 = fields_1.next()) {
                    var field = fields_1_1.value;
                    map.set(field.name, field);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (fields_1_1 && !fields_1_1.done && (_a = fields_1.return)) _a.call(fields_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return map;
        };
        /**
         * @param {?} incoming
         * @param {?} types
         * @return {?}
         */
        AdamantineRestService.parseData = /**
         * @param {?} incoming
         * @param {?} types
         * @return {?}
         */
        function (incoming, types) {
            var e_2, _a;
            if (!tscommonsCore.CommonsType.isEncodedObject(incoming))
                throw new Error('Incoming data is not TEncodedObject');
            /** @type {?} */
            var encoded = (/** @type {?} */ (incoming));
            // don't use decodeObject, as it might try and parse string dates into dates. Do it manually here instead.
            /** @type {?} */
            var map = AdamantineRestService.buildFieldLookup(types);
            /** @type {?} */
            var data = {};
            try {
                for (var _b = __values(Object.keys(encoded)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var key = _c.value;
                    if (!map.has(key))
                        throw new Error('No such type exists for the given key');
                    if (encoded[key] === null)
                        continue;
                    /** @type {?} */
                    var type = map.get(key);
                    if (type === undefined)
                        continue;
                    switch (type.type) {
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.SINGLE:
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.MULTI:
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.PHONE:
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.EMAIL:
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.URL:
                            data[key] = encoded[key].toString();
                            break;
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.BOOLEAN:
                            data[key] = encoded[key] === true || [
                                'true', 'True', 'TRUE',
                                'yes', 'Yes', 'YES',
                                'on', 'On', 'ON',
                                '1'
                            ].includes(encoded[key].toString());
                            break;
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.INTEGER:
                            data[key] = parseInt(encoded[key].toString(), 10);
                            break;
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.FLOAT:
                            data[key] = parseFloat(encoded[key].toString());
                            break;
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.DATE:
                            data[key] = tscommonsCore.CommonsDate.dmYToDate(encoded[key].toString());
                            break;
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.TIME:
                            data[key] = tscommonsCore.CommonsDate.HiToDate(encoded[key].toString());
                            break;
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.DATETIME:
                            data[key] = tscommonsCore.CommonsDate.dmYHiToDate(encoded[key].toString());
                            break;
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.LISTSET:
                            data[key] = encoded[key].toString();
                            break;
                        default:
                        // allow fall-through so subclasses can handle additional custom types
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_2) throw e_2.error; }
            }
            return data;
        };
        /**
         * @param {?} data
         * @param {?} types
         * @return {?}
         */
        AdamantineRestService.encodeData = /**
         * @param {?} data
         * @param {?} types
         * @return {?}
         */
        function (data, types) {
            var e_3, _a;
            /** @type {?} */
            var map = AdamantineRestService.buildFieldLookup(types);
            /** @type {?} */
            var outgoing = {};
            try {
                for (var _b = __values(Object.keys(data)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var key = _c.value;
                    if (!map.has(key))
                        throw new Error('No such type exists for the given key');
                    if (data[key] === null) {
                        outgoing[key] = null;
                        continue;
                    }
                    /** @type {?} */
                    var type = map.get(key);
                    if (type === undefined)
                        continue;
                    switch (type.type) {
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.SINGLE:
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.MULTI:
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.PHONE:
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.EMAIL:
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.URL:
                            outgoing[key] = data[key].toString();
                            break;
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.BOOLEAN:
                            outgoing[key] = data[key] ? true : false;
                            break;
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.INTEGER:
                            outgoing[key] = parseInt(data[key].toString(), 10);
                            break;
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.FLOAT:
                            outgoing[key] = parseFloat(data[key].toString());
                            break;
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.DATE:
                            if (!tscommonsCore.CommonsType.isDate(data[key]))
                                throw new Error('Value is not a date');
                            outgoing[key] = tscommonsCore.CommonsDate.dateTodmY((/** @type {?} */ (data[key])));
                            break;
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.TIME:
                            if (!tscommonsCore.CommonsType.isDate(data[key]))
                                throw new Error('Value is not a date');
                            outgoing[key] = tscommonsCore.CommonsDate.dateToHi((/** @type {?} */ (data[key])));
                            break;
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.DATETIME:
                            if (!tscommonsCore.CommonsType.isDate(data[key]))
                                throw new Error('Value is not a date');
                            outgoing[key] = tscommonsCore.CommonsDate.dateTodmYHi((/** @type {?} */ (data[key])));
                            break;
                        case ngxAdamantinecommonsCore.EAdamantineFieldType.LISTSET:
                            outgoing[key] = data[key].toString();
                            break;
                        default:
                        // allow fall-through so subclasses can handle additional custom types
                    }
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_3) throw e_3.error; }
            }
            return tscommonsCore.CommonsType.encodePropertyObject(outgoing);
        };
        return AdamantineRestService;
    }(ngxHttpcommonsRest.CommonsRestService));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var   /**
     * @abstract
     */
    AdamantineSessionRestService = /** @class */ (function (_super) {
        __extends(AdamantineSessionRestService, _super);
        function AdamantineSessionRestService(rootURL, http) {
            return _super.call(this, rootURL, http) || this;
        }
        /**
         * @param {?} uid
         * @return {?}
         */
        AdamantineSessionRestService.prototype.setSession = /**
         * @param {?} uid
         * @return {?}
         */
        function (uid) {
            this.session = uid;
        };
        /**
         * @return {?}
         */
        AdamantineSessionRestService.prototype.clearSession = /**
         * @return {?}
         */
        function () {
            this.session = undefined;
        };
        /**
         * @private
         * @param {?} script
         * @return {?}
         */
        AdamantineSessionRestService.prototype.extendScript = /**
         * @private
         * @param {?} script
         * @return {?}
         */
        function (script) {
            if (this.session === undefined)
                return script;
            /** @type {?} */
            var char = -1 !== script.indexOf('?') ? '&' : '?';
            return "" + script + char + "session=" + this.session;
        };
        /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?=} params
         * @param {?=} maxReattempts
         * @return {?}
         */
        AdamantineSessionRestService.prototype.internalGet = /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?=} params
         * @param {?=} maxReattempts
         * @return {?}
         */
        function (script, params, maxReattempts) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, _super.prototype.internalGet.call(this, this.extendScript(script), params, maxReattempts)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?} body
         * @param {?=} params
         * @return {?}
         */
        AdamantineSessionRestService.prototype.internalPost = /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?} body
         * @param {?=} params
         * @return {?}
         */
        function (script, body, params) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, _super.prototype.internalPost.call(this, this.extendScript(script), body, params)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?} body
         * @param {?=} params
         * @return {?}
         */
        AdamantineSessionRestService.prototype.internalPut = /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?} body
         * @param {?=} params
         * @return {?}
         */
        function (script, body, params) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, _super.prototype.internalPut.call(this, this.extendScript(script), body, params)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?} body
         * @param {?=} params
         * @return {?}
         */
        AdamantineSessionRestService.prototype.internalPatch = /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?} body
         * @param {?=} params
         * @return {?}
         */
        function (script, body, params) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, _super.prototype.internalPatch.call(this, this.extendScript(script), body, params)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?=} params
         * @return {?}
         */
        AdamantineSessionRestService.prototype.internalDelete = /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?=} params
         * @return {?}
         */
        function (script, params) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, _super.prototype.internalDelete.call(this, this.extendScript(script), params)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        return AdamantineSessionRestService;
    }(AdamantineRestService));
    if (false) {
        /**
         * @type {?}
         * @private
         */
        AdamantineSessionRestService.prototype.session;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var   /**
     * @abstract
     */
    AdamantineExternalKeyRestService = /** @class */ (function (_super) {
        __extends(AdamantineExternalKeyRestService, _super);
        function AdamantineExternalKeyRestService(rootURL, http) {
            var _this = _super.call(this, rootURL, http) || this;
            _this.externalKey = '';
            return _this;
        }
        /**
         * @param {?} key
         * @return {?}
         */
        AdamantineExternalKeyRestService.prototype.setExternalKey = /**
         * @param {?} key
         * @return {?}
         */
        function (key) {
            this.externalKey = key;
        };
        /**
         * @private
         * @param {?} script
         * @return {?}
         */
        AdamantineExternalKeyRestService.prototype.extendScript = /**
         * @private
         * @param {?} script
         * @return {?}
         */
        function (script) {
            /** @type {?} */
            var char = -1 !== script.indexOf('?') ? '&' : '?';
            return "" + script + char + "key=" + this.externalKey;
        };
        /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?=} params
         * @param {?=} maxReattempts
         * @return {?}
         */
        AdamantineExternalKeyRestService.prototype.internalGet = /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?=} params
         * @param {?=} maxReattempts
         * @return {?}
         */
        function (script, params, maxReattempts) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, _super.prototype.internalGet.call(this, this.extendScript(script), params, maxReattempts)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?} body
         * @param {?=} params
         * @return {?}
         */
        AdamantineExternalKeyRestService.prototype.internalPost = /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?} body
         * @param {?=} params
         * @return {?}
         */
        function (script, body, params) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, _super.prototype.internalPost.call(this, this.extendScript(script), body, params)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?} body
         * @param {?=} params
         * @return {?}
         */
        AdamantineExternalKeyRestService.prototype.internalPut = /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?} body
         * @param {?=} params
         * @return {?}
         */
        function (script, body, params) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, _super.prototype.internalPut.call(this, this.extendScript(script), body, params)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?} body
         * @param {?=} params
         * @return {?}
         */
        AdamantineExternalKeyRestService.prototype.internalPatch = /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?} body
         * @param {?=} params
         * @return {?}
         */
        function (script, body, params) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, _super.prototype.internalPatch.call(this, this.extendScript(script), body, params)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?=} params
         * @return {?}
         */
        AdamantineExternalKeyRestService.prototype.internalDelete = /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?=} params
         * @return {?}
         */
        function (script, params) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, _super.prototype.internalDelete.call(this, this.extendScript(script), params)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        return AdamantineExternalKeyRestService;
    }(AdamantineRestService));
    if (false) {
        /**
         * @type {?}
         * @private
         */
        AdamantineExternalKeyRestService.prototype.externalKey;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var   /**
     * @abstract
     */
    AdamantineAuthorizedRestService = /** @class */ (function (_super) {
        __extends(AdamantineAuthorizedRestService, _super);
        function AdamantineAuthorizedRestService(rootURL, http) {
            return _super.call(this, rootURL, http) || this;
        }
        // can't do multiple inheritence in AdamantineRestService, so have to do pass-through to static methods here
        // can't do multiple inheritence in AdamantineRestService, so have to do pass-through to static methods here
        /**
         * @param {?} fields
         * @return {?}
         */
        AdamantineAuthorizedRestService.buildFieldLookup = 
        // can't do multiple inheritence in AdamantineRestService, so have to do pass-through to static methods here
        /**
         * @param {?} fields
         * @return {?}
         */
        function (fields) {
            return AdamantineRestService.buildFieldLookup(fields);
        };
        /**
         * @param {?} incoming
         * @param {?} types
         * @return {?}
         */
        AdamantineAuthorizedRestService.parseData = /**
         * @param {?} incoming
         * @param {?} types
         * @return {?}
         */
        function (incoming, types) {
            return AdamantineRestService.parseData(incoming, types);
        };
        /**
         * @param {?} data
         * @param {?} types
         * @return {?}
         */
        AdamantineAuthorizedRestService.encodeData = /**
         * @param {?} data
         * @param {?} types
         * @return {?}
         */
        function (data, types) {
            return AdamantineRestService.encodeData(data, types);
        };
        return AdamantineAuthorizedRestService;
    }(ngxHttpcommonsRest.CommonsAuthorizedRestService));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var   /**
     * @abstract
     */
    AdamantineKeyAuthorizedRestService = /** @class */ (function (_super) {
        __extends(AdamantineKeyAuthorizedRestService, _super);
        function AdamantineKeyAuthorizedRestService(rootURL, http) {
            return _super.call(this, rootURL, http) || this;
        }
        /**
         * @param {?} key
         * @return {?}
         */
        AdamantineKeyAuthorizedRestService.prototype.setKey = /**
         * @param {?} key
         * @return {?}
         */
        function (key) {
            this.setAuthorization(ngxHttpcommonsRest.ECommonsAuthorizationMethod.KEY, key);
        };
        /**
         * @return {?}
         */
        AdamantineKeyAuthorizedRestService.prototype.clearKey = /**
         * @return {?}
         */
        function () {
            this.setAuthorization(undefined, undefined);
        };
        return AdamantineKeyAuthorizedRestService;
    }(AdamantineAuthorizedRestService));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var   /**
     * @abstract
     */
    AdamantineSessionAuthorizedRestService = /** @class */ (function (_super) {
        __extends(AdamantineSessionAuthorizedRestService, _super);
        function AdamantineSessionAuthorizedRestService(rootURL, http) {
            return _super.call(this, rootURL, http) || this;
        }
        /**
         * @param {?} uid
         * @return {?}
         */
        AdamantineSessionAuthorizedRestService.prototype.setSession = /**
         * @param {?} uid
         * @return {?}
         */
        function (uid) {
            this.setAuthorization(ngxHttpcommonsRest.ECommonsAuthorizationMethod.SESSION, uid);
        };
        /**
         * @return {?}
         */
        AdamantineSessionAuthorizedRestService.prototype.clearSession = /**
         * @return {?}
         */
        function () {
            this.setAuthorization(undefined, undefined);
        };
        /**
         * @return {?}
         */
        AdamantineSessionAuthorizedRestService.prototype.validate = /**
         * @return {?}
         */
        function () {
            return __awaiter(this, void 0, void 0, function () {
                var rest, e_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, this.get("sessions/validate")];
                        case 1:
                            rest = _a.sent();
                            tscommonsCore.CommonsType.assertBoolean(rest);
                            return [2 /*return*/, rest === true];
                        case 2:
                            e_1 = _a.sent();
                            return [2 /*return*/, false];
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        return AdamantineSessionAuthorizedRestService;
    }(AdamantineAuthorizedRestService));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // Prefers sessions over keys, but falls back to keys on the absence of a session
    /**
     * @abstract
     */
    var   
    // Prefers sessions over keys, but falls back to keys on the absence of a session
    /**
     * @abstract
     */
    AdamantineHybridAuthorizedRestService = /** @class */ (function (_super) {
        __extends(AdamantineHybridAuthorizedRestService, _super);
        function AdamantineHybridAuthorizedRestService(rootURL, http) {
            return _super.call(this, rootURL, http) || this;
        }
        /**
         * @param {?} key
         * @return {?}
         */
        AdamantineHybridAuthorizedRestService.prototype.setKey = /**
         * @param {?} key
         * @return {?}
         */
        function (key) {
            this.key = key;
        };
        /**
         * @return {?}
         */
        AdamantineHybridAuthorizedRestService.prototype.clearKey = /**
         * @return {?}
         */
        function () {
            this.key = undefined;
        };
        /**
         * @param {?} uid
         * @return {?}
         */
        AdamantineHybridAuthorizedRestService.prototype.setSession = /**
         * @param {?} uid
         * @return {?}
         */
        function (uid) {
            this.session = uid;
        };
        /**
         * @return {?}
         */
        AdamantineHybridAuthorizedRestService.prototype.clearSession = /**
         * @return {?}
         */
        function () {
            this.session = undefined;
        };
        /**
         * @return {?}
         */
        AdamantineHybridAuthorizedRestService.prototype.hasSession = /**
         * @return {?}
         */
        function () {
            return this.session !== undefined;
        };
        /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?=} params
         * @param {?=} maxReattempts
         * @param {?=} headers
         * @return {?}
         */
        AdamantineHybridAuthorizedRestService.prototype.internalGet = /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?=} params
         * @param {?=} maxReattempts
         * @param {?=} headers
         * @return {?}
         */
        function (script, params, maxReattempts, headers) {
            return __awaiter(this, void 0, void 0, function () {
                var method, value;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (this.session !== undefined) {
                                method = ngxHttpcommonsRest.ECommonsAuthorizationMethod.SESSION;
                                value = this.session;
                            }
                            else if (this.key !== undefined) {
                                method = ngxHttpcommonsRest.ECommonsAuthorizationMethod.KEY;
                                value = this.key;
                            }
                            return [4 /*yield*/, this.fixedAuthorizationGet(method, value, script, params, maxReattempts, headers)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?} body
         * @param {?=} params
         * @param {?=} headers
         * @return {?}
         */
        AdamantineHybridAuthorizedRestService.prototype.internalPost = /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?} body
         * @param {?=} params
         * @param {?=} headers
         * @return {?}
         */
        function (script, body, params, headers) {
            return __awaiter(this, void 0, void 0, function () {
                var method, value;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (this.session !== undefined) {
                                method = ngxHttpcommonsRest.ECommonsAuthorizationMethod.SESSION;
                                value = this.session;
                            }
                            else if (this.key !== undefined) {
                                method = ngxHttpcommonsRest.ECommonsAuthorizationMethod.KEY;
                                value = this.key;
                            }
                            return [4 /*yield*/, this.fixedAuthorizationPost(method, value, script, body, params, headers)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?} body
         * @param {?=} params
         * @param {?=} headers
         * @return {?}
         */
        AdamantineHybridAuthorizedRestService.prototype.internalPut = /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?} body
         * @param {?=} params
         * @param {?=} headers
         * @return {?}
         */
        function (script, body, params, headers) {
            return __awaiter(this, void 0, void 0, function () {
                var method, value;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (this.session !== undefined) {
                                method = ngxHttpcommonsRest.ECommonsAuthorizationMethod.SESSION;
                                value = this.session;
                            }
                            else if (this.key !== undefined) {
                                method = ngxHttpcommonsRest.ECommonsAuthorizationMethod.KEY;
                                value = this.key;
                            }
                            return [4 /*yield*/, this.fixedAuthorizationPut(method, value, script, body, params, headers)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?} body
         * @param {?=} params
         * @param {?=} headers
         * @return {?}
         */
        AdamantineHybridAuthorizedRestService.prototype.internalPatch = /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?} body
         * @param {?=} params
         * @param {?=} headers
         * @return {?}
         */
        function (script, body, params, headers) {
            return __awaiter(this, void 0, void 0, function () {
                var method, value;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (this.session !== undefined) {
                                method = ngxHttpcommonsRest.ECommonsAuthorizationMethod.SESSION;
                                value = this.session;
                            }
                            else if (this.key !== undefined) {
                                method = ngxHttpcommonsRest.ECommonsAuthorizationMethod.KEY;
                                value = this.key;
                            }
                            return [4 /*yield*/, this.fixedAuthorizationPatch(method, value, script, body, params, headers)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?=} params
         * @param {?=} headers
         * @return {?}
         */
        AdamantineHybridAuthorizedRestService.prototype.internalDelete = /**
         * @protected
         * @template T
         * @param {?} script
         * @param {?=} params
         * @param {?=} headers
         * @return {?}
         */
        function (script, params, headers) {
            return __awaiter(this, void 0, void 0, function () {
                var method, value;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (this.session !== undefined) {
                                method = ngxHttpcommonsRest.ECommonsAuthorizationMethod.SESSION;
                                value = this.session;
                            }
                            else if (this.key !== undefined) {
                                method = ngxHttpcommonsRest.ECommonsAuthorizationMethod.KEY;
                                value = this.key;
                            }
                            return [4 /*yield*/, this.fixedAuthorizationDelete(method, value, script, params, headers)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        /**
         * @return {?}
         */
        AdamantineHybridAuthorizedRestService.prototype.validate = /**
         * @return {?}
         */
        function () {
            return __awaiter(this, void 0, void 0, function () {
                var rest, e_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.hasSession())
                                return [2 /*return*/, false];
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, this.get("sessions/validate")];
                        case 2:
                            rest = _a.sent();
                            tscommonsCore.CommonsType.assertBoolean(rest);
                            return [2 /*return*/, rest === true];
                        case 3:
                            e_1 = _a.sent();
                            return [2 /*return*/, false];
                        case 4: return [2 /*return*/];
                    }
                });
            });
        };
        return AdamantineHybridAuthorizedRestService;
    }(AdamantineAuthorizedRestService));
    if (false) {
        /**
         * @type {?}
         * @private
         */
        AdamantineHybridAuthorizedRestService.prototype.key;
        /**
         * @type {?}
         * @private
         */
        AdamantineHybridAuthorizedRestService.prototype.session;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxAdamantineCommonsRestModule = /** @class */ (function () {
        function NgxAdamantineCommonsRestModule() {
        }
        NgxAdamantineCommonsRestModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule
                        ],
                        declarations: []
                    },] }
        ];
        return NgxAdamantineCommonsRestModule;
    }());

    exports.AdamantineAuthorizedRestService = AdamantineAuthorizedRestService;
    exports.AdamantineExternalKeyRestService = AdamantineExternalKeyRestService;
    exports.AdamantineHybridAuthorizedRestService = AdamantineHybridAuthorizedRestService;
    exports.AdamantineKeyAuthorizedRestService = AdamantineKeyAuthorizedRestService;
    exports.AdamantineRestService = AdamantineRestService;
    exports.AdamantineSessionAuthorizedRestService = AdamantineSessionAuthorizedRestService;
    exports.AdamantineSessionRestService = AdamantineSessionRestService;
    exports.NgxAdamantineCommonsRestModule = NgxAdamantineCommonsRestModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-adamantinecommons-rest.umd.js.map
