import { HttpClient } from '@angular/common/http';
import { AdamantineRestService } from './adamantine-rest.service';
import { TEncodedObject } from 'tscommons-core';
export declare abstract class AdamantineExternalKeyRestService extends AdamantineRestService {
    private externalKey;
    constructor(rootURL: string, http: HttpClient);
    setExternalKey(key: string): void;
    private extendScript;
    protected internalGet<T>(script: string, params?: TEncodedObject, maxReattempts?: number): Promise<T>;
    protected internalPost<T>(script: string, body: TEncodedObject, params?: TEncodedObject): Promise<T>;
    protected internalPut<T>(script: string, body: TEncodedObject, params?: TEncodedObject): Promise<T>;
    protected internalPatch<T>(script: string, body: TEncodedObject, params?: TEncodedObject): Promise<T>;
    protected internalDelete<T>(script: string, params?: TEncodedObject): Promise<T>;
}
