import { HttpClient } from '@angular/common/http';
import { TPropertyObject } from 'tscommons-core';
import { TEncodedObject } from 'tscommons-core';
import { CommonsRestService } from 'ngx-httpcommons-rest';
import { IAdamantineField } from 'ngx-adamantinecommons-core';
export declare abstract class AdamantineRestService extends CommonsRestService {
    static buildFieldLookup(fields: IAdamantineField[]): Map<string, IAdamantineField>;
    static parseData(incoming: any, types: IAdamantineField[]): TPropertyObject;
    static encodeData(data: TPropertyObject, types: IAdamantineField[]): TEncodedObject;
    constructor(rootURL: string, http: HttpClient);
}
